;grid512b
;by Shiru 10'2008 for ASCiI'08

; SjASMPlus

; 

; 0,1,2,3 -  
; 4,6,7 -     
; 5 -    

;6200 ,     

;7000,7100,7200,7300,7400,7500,7600,7700 - 
;6e00 -  
;6f6f -   (ei:ret)
;7840 -     (140 )
;7a00 -     
;7c00 -   (512 )
;7e10 - 


    device zxspectrum128

OP_JP       equ #c3
OP_LD_DE    equ #11
OP_PUSH_DE  equ #d5
OP_RET      equ #c9

STACK_A     equ #2d28
FP_TO_A     equ #2dd5
STACK_BC    equ #2d2b
FP_TO_BC    equ #2da2

CLS         equ #0d6b
BORDER      equ #5c48
ATTR_P      equ #5c8d

    org #6200
 
begin

    di
    ld sp,#6100
 
; ,    

cls

    ld a,16+7   ;  BASIC48,   
    out (#fd),a
    ld a,#47
    ld (BORDER),a
    ld (ATTR_P),a
    call CLS
    ld hl,#4000
    ld d,#c0
    ld b,h
    ldir
    out (#fe),a
 
;  

gen_scale_table

    ld hl,#7c00
    ld bc,#0108
.loop0
    push bc
    push hl
    push hl
    call STACK_BC
    pop bc
    ld b,0
    inc bc
    call STACK_BC
    ld b,4 ; 1024
    call STACK_BC
    rst #28
    db #04 ;multiply
    db #01 ;exchange
    db #05 ;division
    db #38 ;end
    call FP_TO_BC
    pop hl
    ld (hl),c
    inc h
    ld (hl),b
    dec h
    pop bc
    dec bc
    inc l
    jr nz,.loop0
 
;    

gen_graphics

    ld ix,#1014 ;ixl=listPage ixh=gfxPage

    xor a
.loop0
    push af

    call STACK_A
    ld a,#40 ; 64*sin(0..255)
    call STACK_A
    rst #28
    db #01
    db #a3
    db #34,#40,#b0,#00,#40
    db #05
    db #04
    db #1f
    db #04
    db #38
    call FP_TO_A
    jr z,$+3
    cpl
    add a,128
 
    ;    

    ld d,b
    ld e,a

    ld a,ixh
    out (#fd),a
    ld iy,(gfxOffset)
 
.loop1
    ld h,#79 ;   (512 )
.loop2
    ld (hl),0
    inc hl
    bit 2,h
    jr z,.loop2

    ld bc,#0301
    ld hl,plane_counters
.loop3
    push bc
    push hl
    push de
 
    call getSize
    ld h,#7a
    ld l,e
 
    ld e,a
    ld a,d
    and c
    ld a,e
    jr z,$+3
    xor a

    ld d,h
    ld e,l
    ld b,192
.loop4
    cp (hl)
    dec de
    jr c,$+4
    ld (hl),a
    ld (de),a
    inc hl
    exx
    dec h
    ld b,h
    inc b
    jr nz,.loop5
    add hl,de
    xor c
.loop5
    exx
    djnz .loop4
 
    pop de
    pop hl
    pop bc
    sla c
    inc hl
    djnz .loop3
 
    push de

    ;  

    ld de,#7aff
.loop6
    ld hl,gfx_dither
    ld b,8
.loop7
    ld a,(de)
    cp (hl)
    ccf
    rr c
    inc hl
    dec de
    djnz .loop7
    ld (iy),c
    inc iy
    bit 0,d
    jr z,.loop6

    pop de
    inc d
    bit 3,d
    jr z,.loop1
 
    ;     

    ld a,ixl
    out (#fd),a
    ld hl,(listOffset)
 
    ld bc,#4670
.loop8
    ld (hl),c
    inc hl
    djnz .loop8

    ex de,hl
    ld bc,#0301
    ld hl,plane_counters
.loop9
    push bc
    push hl
    push de
 
    call getSize
    inc (hl)
 
    ld b,70
    xor a
    ld h,d
    ld l,e
.loop10
    or a
    push af
    dec hl
    ld a,(hl)
    jr nz,.loop11
    or c
    ld (hl),a
.loop11
    ld (de),a
    inc de
    pop af
    exx
    dec h
    jp p,.loop12
    add hl,de
    cpl
.loop12
    exx
    djnz .loop10
    pop de
    pop hl
    pop bc
    sla c
    inc hl
    djnz .loop9
 
    call nextFrame

    pop af
    dec a
    jp nz,.loop0

; 

gen_outers

    ld h,#70    ;  
.loop0
    ld l,a      ;  ,  a  0
    ld b,16     ; 
.loop1
    ld (hl),OP_LD_DE
    inc l
    inc l
    inc l
    ld (hl),OP_PUSH_DE
    inc l
    djnz .loop1
    ld (hl),OP_JP
    inc l
    ld (hl),render1&255
    inc l
    ld (hl),render1/256
    inc h
    bit 3,h
    jr z,.loop0
 
; im2
 
    ld hl,#6f6f ;  #6f6f
    ld (hl),OP_RET
    ld a,h
    dec hl
    ld (hl),a
    bit 1,h
    jr nz,$-4
    dec a
    ld i,a
    im 2

; 

    ld iy,#0700 ;iyl=screen view iyh=screen page

mainLoop

    ei
    halt
 
; 

    ld a,ixh
    or iyl
    out (#fd),a

    ld sp,(gfxOffset)
    ld h,#70
prepare1
    ld l,b
    ld b,16
prepare2
    pop de
    inc l
    ld (hl),d
    inc l
    ld (hl),e
    inc l
    inc l
    djnz prepare2
    inc h
    bit 3,h
    jr z,prepare1

;   

    ld a,ixl
    or iyl
    out (#fd),a
    ld sp,(listOffset)
    ld b,70
copy0
    pop de
    ld (hl),e
    inc l
    ld (hl),d
    inc l
    djnz copy0

; 

    ld a,8
    xor iyl
    ld iyl,a
    ld a,10
    xor iyh
    ld iyh,a
    out (#fd),a
 
    ex de,hl
    ld b,140
    ld hl,#c27f

render0
    ld sp,hl
    inc sp
    dec e
    ld a,(de)
    exx
    ld l,0
    ld h,a
    jp (hl)
render1
    exx
 
;DOWN_HL+ by Spencer Winsent
    inc h
    ld a,h
    and #07
    jr nz,render2
    ld a,l
    sub #e0
    ld l,a
    sbc a,a
    and #f8
    add a,h
    ld h,a
render2

    djnz render0
 
    ld hl,mainLoop
    ld sp,hl
    push hl
 

nextFrame
gfxOffset=$+1
    ld hl,#c000
    inc h
    jr nz,listIncOff
    ld h,#c0
    ld a,ixh
    inc a
    and 16+3
    ld ixh,a
listIncOff
    ld (gfxOffset),hl
listOffset=$+1
    ld hl,#c100
    ld c,144
    add hl,bc
    jr nc,listIncRet
    ld a,ixl
    inc a
    and #17
    or #14
    cp #15
    jr z,$-7
    ld ixl,a
    ld h,#c1
    cp #17
    jr nz,$+4
    ld h,#ee
listIncRet
    ld (listOffset),hl
    ret

getSize
    ld a,(hl)
    exx
    ld h,#7c
    ld l,a
    ld e,(hl)
    inc h
    ld d,(hl)
    ld h,d
    ld l,e
    add hl,hl
    ex de,hl
    ld a,h ; 
    ld c,h ;
    exx
    ret


gfx_dither      db 1,16,4,21,2,18,6,23
plane_counters  db 0,85,170


end

    display /d,$-begin


    savesna "grid512b.sna",begin
    savebin "grid512b.bin",begin,end-begin